/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laboratorul 1
 * Digital I/O
 *********************************************************************************/

#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>

#include "lcd.h"

/* Generare secvente aprindere leduri */
void task1()
{
	/*	TODO */
	/* 	Setare directii porturi folosite	*/
	DDRC = 0xFF;
	DDRB = 0;
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	
	int stare = 1;
	
	while(1) {

		//Generare secvente pentru PB1 si PB0
		if ((PINB & (1 << PB0)) == 0){
			stare = 1;
		}
		
		if ((PINB & (1 << PB1)) == 0){
			stare = 2;
		}
			
		if (stare == 1){
			PORTC = PORTC ^ (1 << PC0);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC1);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC2);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC3);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC4);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC5);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC6);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC7);	// inversam starea ledului
			_delay_ms(100);
		} else {
			PORTC = PORTC ^ (1 << PC0);	// inversam starea ledului
			PORTC = PORTC ^ (1 << PC7);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC1);	// inversam starea ledului
			PORTC = PORTC ^ (1 << PC6);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC2);	// inversam starea ledului
			PORTC = PORTC ^ (1 << PC5);	// inversam starea ledului
			_delay_ms(100);
			PORTC = PORTC ^ (1 << PC3);	// inversam starea ledului
			PORTC = PORTC ^ (1 << PC4);	// inversam starea ledului
			_delay_ms(100);			
		}
	}
}

/* Afisare mesaj simplu */
void task3(char * mesaj)
{	
	/* TODO */
	/* 	Initializare LCD	*/	
	LCD_init();
	/*	Afisare mesaj	*/
	LCD_print("Helou!");
	
	while(1)
	{
		LCD_writeInstruction(0x18); // shiftare stanga
		_delay_ms(250);
	}
		
	
	
	
}

void task4()
{
	/*	TODO */
	/* afisare mesaj */
	
	while(1) {
		/*	Actiuni butoane*/
		
	
	}
	
}

/* 	Miscare caracter custom pe ecran	*/
void task5()
{
	/*	TODO */
}

/*	Afisare caracter custom 	*/
void printCustomChar()
{

    unsigned char A[2][20][8];
	unsigned char linieV[8] = {
	0b10000,
	0b10000,
	0b10000,
	0b00000,
	0b00000,
	0b00000,
	0b00000,
	0b00000
};

	unsigned char linieO[8] = {
	0b11100,
	0b00000,
	0b00000,
	0b00000,
	0b00000,
	0b00000,
	0b00000,
	0b00000
};

	unsigned char patrat[8] = {
		0b11000,
		0b11000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char z[8] = {
		0b11000,
		0b01100,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char zi[8] = {
		0b01000,
		0b11000,
		0b10000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char t[8] = {
		0b01000,
		0b11100,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char ti[8] = {
		0b01000,
		0b1100,
		0b01000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char ti[8] = {
		0b01000,
		0b01100,
		0b01000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char ti[8] = {
		0b01000,
		0b01100,
		0b01000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char ts[8] = {
		0b01000,
		0b11100,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char tr[8] = {
		0b01000,
		0b11000,
		0b01000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char zs[8] = {
		0b01100,
		0b11000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
	unsigned char zsi[8] = {
		0b01000,
		0b01100,
		0b00100,
		0b00000,
		0b00000,
		0b00000,
		0b00000,
		0b00000
	};
	
}


int main()
{
	//task1();
	task3("Hello Hardware World!");
	task4();
	task5();
	while(1);
	
	return 0;
}
